#!/usr/bin/perl
#f:\perl\perl.exe
# =============================================================================
# Fmorefnd.pl - V1.0a by Dog_food (email dog.food@poboxes.com)
#
# Purpose
#  - CGI part of fragmore.pl
#  - This shows only the people that have been fragged by this _player_ and also
#    those who have fragged the _player_.
#  - Max listing length is 100 players
#
# Comments
#  - Exact search will yeild a max of one result (case sensitive)
#  - Assumes files haven't been tempered with (ie must have some number of
#    lines in both database files)
#  - Fixed engine in giving out stupid results which weren't local to the
#    player
#  - Clearer output
#
# To do
#  - Index, to provide easy jump points
#  - Rewrite initial code
#  - Implement CGI correctly
#  - Friendly page
#
# Hey!, do that again, I missed where your brains went
# It's a dog eat dog world
# Beep, beep
# =============================================================================

require "/usr/local/bin/frag-lib.pl";	# rawstats common functions

# === User changeable variables ===============================================
$morever = "V1.0a 2/6/97";
$shwlimit = 10;				# max number of players to show
$maxfrag = 99999;			# requires by hash sorting key
$maxresults = 32;			# max players that can be found
$linknames = 1;

# =============================================================================
# read in player id file
open(PLAYIDDB, "$playiddb") or die "Can't open $playiddb: $!\n";
while ($line = <PLAYIDDB>) {
  chop $line;
  ($playid,$player) = split (/,/,$line);
  $id{$playid} = $player;
}
close PLAYIDDB;

# === Webpage header ==========================================================
sub header {
  print "Content-Type: text/html\n\n";

$exactflg==1 && ($typeopt="<OPTION>Exact<OPTION>Substring");
$exactflg==0 && ($typeopt="<OPTION>Substring<OPTION>Exact");
$barlink = &createbar;
	
print <<EOFHEADER
<HTML>
<!-- Rawstats, generated webpage by Dog_food -->
<TITLE>Rawstats - most killed, most victim of ("$searchkey")</TITLE>
<BODY text=#FFFFFF bgcolor=#000000 LINK=#00FF00 VLINK=#00FFFF ALINK=#00FFFF>
<I>$barlink</I>
<H1>Rawstats</H1>

<FORM METHOD="GET" ACTION="/cgi-bin/fmorefnd.pl">
	<TABLE BORDER=1 CELLPADDING=5 bgcolor=#004422><TR>
	<TD><B>Stat search</B></TD>
	<TD>
		Player <INPUT NAME="name" VALUE="$searchkey">
		Type <SELECT name="match">$typeopt</SELECT>
		<INPUT TYPE=SUBMIT>
	</TD>
	</TR></TABLE>
</FORM>
If you can't remember a player name you can either try a substring using a part
of the players name. The search engine still has a few bugs, mainly trying to
find players with silly characters in their name :)  A maximum of $maxresults
results will be return in any query.
<HR>
<CENTER>
EOFHEADER
}

# === Webpage footer ==========================================================
sub footer {
  $playmatch==0 && ($matchsz="No player results");
  $playmatch==1 && ($matchsz="One player result");
  $playmatch>1 && ($matchsz="$playmatch player results");

print <<EOFFOOTER
<BR>$matchsz found<BR>
<HR>
</CENTER>


<B>Search Results</B><BR>
The table below explains how to read the results.  If you have any diffculties,
please mail me.<BR>
<TABLE BORDER=1 bgcolor=#004422>
<TR>
	<TD><B>Frags</B></TD>
	<TD>Shows who a person get fragged by the most and the number of frags.
	Only the top ten victims are listed</TD>
</TR><TR>
	<TD><B>Deaths</B></TD>
	<TD>Shows who a person got killed by the most and number of deaths.
	Only the top ten killers are listed</TD>
</TR><TR>
	<TD><B>Count</B></TD>
	<TD>Number of different players that been killed or been a victim of.
	</TD>
</TR><TR>
	<TD>Suicides</TD>
	<TD>If a person suicides it also show up in the deaths and frags count.
	Someone worst enermy could be themselves.</TD>
</TR>
</TABLE>

<BR><B>Bugs in searching</B>
<BR>If you find problems searching for a player name, please mail me the name
    and I'll try and sort out any problems.  I suggest you use a normal
    player search first, before trying the stat search.

<BR CLEAR=all>
<FONT SIZE=-1>
<BR>Rawstats - Stat search $morever by Dog_food<BR>
Email <A HREF="mailto:dog.food\@poboxes.com">dog.food\@poboxes.com</A><BR>
</FONT></BODY>
</HTML>
EOFFOOTER
}

# === Parse CGI or commandline ================================================
$searchkey = $ARGV[0];
$QUERY_STRING = $ENV{'QUERY_STRING'};
@vars = split ("&",$QUERY_STRING);

foreach $var (@vars) {
  ($varname, $vardata) = split ("=",$var);
  $vardata =~ s/\+/ /g;
  $vardata =~ s/%([a-fA-F0-9]{2})/chr(hex($1))/ge;
  $fields{$varname} = $vardata;
}

if ($searchkey eq "") {					# if not only cmdline, then assume web
  $searchkey = $fields{"name"};				# was used, using the get method
  $exactflg = $fields{"match"};
  logcgi();
  if ($searchkey eq "") {
    $searchkey = "Empty field,"				# something which won't match
  }							# need to break out earlier here
}

if ($exactflg eq "Exact") {				# make sure it's boolean
  $exactflg = 1;
} else {
  $exactflg = 0;
}

# =============================================================================
sub tabrow {
  chop $line2;
  ($player2,@plist2) = split(",",$line2);
  $player2 = $id{$player2};
  
  local (%kills,%deaths,%tablea,%tableb);
  $victims = $killers = 0;

  if ($player1 eq $player2) {
    # Generate unqiue hashing key
    foreach $personct (@plist) {
      ($person,$ct) = split /\\/,$personct;
      $person = $id{$person};
      $skey = sprintf "%06d%s", $maxfrag - $ct, $person;
      $kills{$skey} = sprintf "<TD>%s</TD><TD>$ct</TD>", createlink($person,$linknames);
      $killers++;
    }
    foreach $personct (@plist2) {
      ($person,$ct) = split /\\/,$personct;
      $person = $id{$person};
      $skey = sprintf "%06d%s", $maxfrag - $ct, $person;
      $deaths{$skey} = sprintf "<TD>%s</TD><TD>$ct</TD>", createlink($person,$linknames);
      $victims++;
    }
    $killct = 1;
    foreach $player (sort keys %kills) {
      if ($killct <= $shwlimit) {
      	$tablea{$killct} = $player;
      	$killct++;
      }
    }
    $deathct = 1;
    foreach $player (sort keys %deaths) {
      if ($deathct <= $shwlimit) {
      	$tableb{$deathct} = $player;
      	$deathct++;
      }
    }
    $maxrows = ($killct > $deathct)*$killct + ($killct <= $deathct)*$deathct;
    print "<P><TABLE BORDER=1 bgcolor=#224455>\n";
    print "<TR ALIGN=center><TH><I>Player</I></TH><TH COLSPAN=2><I>Frags</I></TH><TH COLSPAN=2><I>Deaths</I></TH></TR>";
    print "<TR ALIGN=center><TH><I>$player1</I></TH><TH><I>Name</I></TH><TH><I>no.</I></TH><TH><I>Name</I></TH><TH><I>no.</I></TH></TR>\n";
    for ($i=1; $i<$maxrows; $i++) {
      print "<TR ALIGN=right><TD ALIGN=center><I>$i</I></TD>";
      if ($deaths{$tableb{$i}} eq "") {
        print "<TD ALIGN=center>-</TD><TD ALIGN=center>-</TD>";
      } else {
        print $deaths{$tableb{$i}};
      }
      if ($kills{$tablea{$i}} eq "") {
        print "<TD ALIGN=center>-</TD><TD ALIGN=center>-</TD>";
      } else {
        print $kills{$tablea{$i}};
      }
      print "</TR>\n";
    }
    print "<TR ALIGN=center><TD><B><I>Counts</I></B></TD><TD>$victims victim";
    $victims>1 && print "s";
    print "</TD><TD>-</TD><TD>$killers killer";
    $killers>1 && print "s";
    print "</TD><TD>-</TD></TR>\n";
    print "</TABLE></P>\n\n";
  } else {
#    print "Non matching names, is database corrupt?\n";
  }
}

# =============================================================================
$playmatch = 0;			# number of matches found in non exact search

open(DEATHSDB, "$deathsdb") or die "Can't open deaths database: $!\n";
open(FRAGSDB, "$fragsdb") or die "Can't open frags database: $!\n";

header;

while ($line = <DEATHSDB>) {
  if ($playmatch < $maxresults) {	# max results to find
    $line2 = <FRAGSDB>;
    chop $line;
    ($player1,@plist) = split(",",$line);
    $player1 = $id{$player1};
    if ($exactflg==0 && ($player1 =~ /$searchkey/ig)) {
      tabrow();
      $playmatch++;
    } elsif ($exactflg==1 && ($player1 eq $searchkey)) {
      tabrow();
      $playmatch++;
    }
  }
}

footer;

close DEATHSDB;
close FRAGSDB;
