#Rawstats - Library functions
#frag-lib.pl V1.1 Email dog.food@poboxes.com
# =============================================================================

require "/usr/local/bin/cgi-lib.pl";
require 'ctime.pl';			# last time this script was ran

# === Configuration paths =====================================================
# Local files
$log_file	= "/home/bob/incoming/cgi-log.html";
$srchpage 	= "/var/lib/httpd/htdocs/search.html";
$qwrpage 	= "/var/lib/httpd/htdocs/qwranks.html";
$fragpage	= "/var/lib/httpd/htdocs/fragstat2.html";  # output webpage
$fraglogs 	= "/var/lib/qw/frag.dat";	# input log file (cat the logs)
$statpath 	= "/var/lib/qw/stats.db";	# output database
$playiddb 	= "/var/lib/qw/playid.db";	# player id file
$deathsdb 	= "/var/lib/qw/deaths.db";
$fragsdb 	= "/var/lib/qw/frags.db";
$outpath 	= "/var/lib/qw/";		# output webfiles ie "/var/lib/qw/"

# Remote files
$srchcgi 	= "/cgi-bin/fragsrch.pl";
$statcgi	= "/cgi-bin/fmorefnd.pl";
$commcgi	= "/cgi-bin/fragcomm.pl";

# Ranking configuration for generated pages
$prefix 	= "qw_";	# prefix to webfiles - webpath only ie "qw_"
$splitpage 	= 100;		# players per page (range=1+)

# === Create page bar in a webpage ============================================
sub createbar {
  local($idx) = @_;
  local $buildsz = "";

  $bar{1} = "Frontpage";
  $lnk{1} = "http://130.88.128.166/";
  $bar{2} = "QW Rankings";
  $lnk{2} = "/qwranks.html";
  $bar{3} = "Search & Message";
  $lnk{3} = "/search.html";
  $bar{4} = "Hi frags";
  $lnk{4} = "/fragstat.html";
  $bar{5} = "Top 100";
  $lnk{5} = "/" . $prefix . "1.html";
  $bar{6} = "All players";
  $lnk{6} = "/allplay.html";
  $bar{7} = "Rawstats";
  $lnk{7} = "/~bob/";

  foreach $link (sort keys %bar) {
    if ($idx == $link) {
      $buildsz .= "<B>$bar{$link}</B> / ";
    } else {
      $buildsz .= "<A HREF=\"$lnk{$link}\">$bar{$link}</A> / ";
    }
  }
  return $buildsz;
}

# === Create a player link in html ============================================
sub createlink {
  local($name,$doit) = @_;
  if ($doit == 0) {
    return "$name";
  } else {
    local $orgname = $name;
    $name =~ s/ /%20/g;
    $name =~ s/\+/%2B/g;
    return "<A HREF=\"$statcgi?match=Exact&name=$name\">$orgname</A>";
  }
}

sub cslink {
  local($name,$doit) = @_;
  if ($doit == 0) {
    return "$name";
  } else {
    local $orgname = $name;
    $name =~ s/ /%20/g;
    $name =~ s/\+/%2B/g;
    return "<A HREF=\"$srchcgi?name=$name\">$orgname</A>";
  }
}

# === Checks if a given line is a comment, returns true/false =================
sub iscomment {
  ($_) = @_;
  if (/\\/) {
    return(1);
  } else {
    return(0);
  }
}

# Test - test test test test, experimental stuff

# === Make activity bar =======================================================
sub activepc {
  local($curr,$max) = @_;
  local $curr, $i, $imgsz="";

  $curr = int (10/$max*$curr);
  if ($curr >=0 && $curr<10) {
    for($i=0; i<$curr; $i++) {
    	$imgsz .= "<IMG SRC=A$i.JPG>";
    }
  }
  return $imgsz;
}

# === Log CGI data ============================================================
sub logcgi {
  # NOTE : make sure I can write to the log diretory
	
  local $lastupd = &ctime(time);	# get current time, used later
  chop $lastupd;

  open LOGCGI, ">>$log_file" or die "Can't create log cgi";
  print LOGCGI "<br>=== $lastupd ============================\n";
  if (&ReadParse(*input)) {
    print LOGCGI &PrintHeader, &PrintVariables(%input);
  }
  print LOGCGI "<br>AUTH_PASS:       ",    $ENV{'AUTH_PASS'}, "\n";
  print LOGCGI "<br>CONTENT_LENGTH:  ",    $ENV{'CONTENT_LENGTH'}, "\n";
  print LOGCGI "<br>PATH_INFO:       ",    $ENV{'PATH_INFO'}, "\n";
  print LOGCGI "<br>PATH_TRANSLATED: ",    $ENV{'PATH_TRANSLATED'}, "\n";
  print LOGCGI "<br>QUERY_STRING:    ",    $ENV{'QUERY_STRING'}, "\n";
  print LOGCGI "<br>REMOTE_ADDR:     ",    $ENV{'REMOTE_ADDR'}, "\n";
  print LOGCGI "<br>REMOTE_HOST:     ",    $ENV{'REMOTE_HOST'}, "\n";
  print LOGCGI "<br>REMOTE_USER:     ",    $ENV{'REMOTE_USER'}, "\n";
  print LOGCGI "<br>REQUEST_METHOD:  ",    $ENV{'REQUEST_METHOD'}, "\n";
  print LOGCGI "<br>SCRIPT_NAME:     ",    $ENV{'SCRIPT_NAME'}, "\n";
#  print LOGCGI "<br>SERVER_NAME:     ",    $ENV{'SERVER_NAME'}, "\n";
#  print LOGCGI "<br>SERVER_PORT:     ",    $ENV{'SERVER_PORT'}, "\n";
#  print LOGCGI "<br>SERVER_PROTOCOL: ",    $ENV{'SERVER_PROTOCOL'}, "\n";
#  print LOGCGI "<br>SERVER_SOFTWARE: ",    $ENV{'SERVER_SOFTWARE'}, "\n";
  close LOGCGI;
}

1;
