#!/usr/bin/perl
# =============================================================================
# Converts existing log file into a another format
# Generates two files fraglog.db, playid.db
# Use fraguidx.pl to convert generated files back to original format
# Purpose :
#   replace players names with no ones
#   correct corrupt log files
# V1.2 by Dog_food 2/6/97
#

$play_id = 1;
$line_ct = 1;
$highest = $hi_vict = $hi_kill = 0;
$repeat_ct = 0;
$last_kill = $last_vict = 0;

sub outbuff1 {
  local($killer,$victim) = @_;
  if ($killer && $victim) {
    print FLOGSDB "$killer,$victim\n";	# write log file in new format
  }
}

sub outbuff2 {
  local($killer,$victim) = @_;
  if (!$killer && !$victim && $repeat-ct>0) {	# flush buffer
    printf FLOGSDB "%lx,%lx,%lx\n", $repeat_ct,$last_kill,$last_vict;
  }
  if (($killer==$last_kill) && ($victim==$last_vict) && $last_vict) {
    $repeat_ct++;
    if (($repeat_ct>$highest) && ($last_kill!=$last_vict)) {
      $highest = $repeat_ct;
      $hi_kill = $last_kill;
      $hi_vict = $last_vict;
    }
  } else {
    printf FLOGSDB "%lx,%lx,%lx\n", $repeat_ct,$last_kill,$last_vict;
    $last_kill = $killer;
    $last_vict = $victim;
    $repeat_ct = 1;
  }
}

open(F_FRAGS, "/var/lib/qw/frag.dat");
open FLOGSDB, ">fraglog.db";
while ($line = <F_FRAGS>) {
  chop $line;
  $slashct = $line =~ tr/\\/\\/;
  if ($slashct==3) {
    $line =~ s/(,)//g;				# strip commas
    $line =~ s/</&lt/g;				# get rid of possible html tags
    $line =~ s/>/&gt/g;				# get rid of possible html tags
    $line =~ s/\\(.*?)\\(.*?)\\/$1,$2/;		# now in [name,name] format
    ($killer,$victim) = split(",",$line);	# split on comma
    
#    $outline = "$killer,$victim";		# regeneration check
#    if ($outline ne $line) {
#      print "[$line] ne [$outline]\n";
#    }
    
    if ($id{$killer} == 0) {			# if new player then assign an id
      $id{$killer} = $play_id;
      $play_id++;
      print "$play_id\r";				# show progress
    }
    if ($id{$victim} == 0) {			# if new player then assign an id
      $id{$victim} = $play_id;
      $play_id++;
      print "$play_id\r";			# show progress
    }
    outbuff1($id{$killer}, $id{$victim});
  } else {
    print "[$line] isn't in the correct format\n";
  }
}
# outbuff2(0,0);					# flush buffer
close F_FRAGS;
close FLOGSDB;

open PLAYIDDB, ">playid.db";			# write player id list
foreach $player (sort keys %id) {
  print PLAYIDDB "$id{$player}\\$player\n";
}
close PLAYIDDB;

printf "Totals players = %d\n", $play_id-1;
printf "Highest run was %d by $hi_kill killing $hi_vict\n", $highest;
