#!/usr/bin/perl
#f:\perl\perl.exe
# =============================================================================
# Fragmore.pl - V1.0 by Dog_food (email dog.food@poboxes.com)
#
# Purpose
#  -Creates database files (deaths.db, frags.db) to CGI processing
#  -Requires frag.dat (cat the log files into one file)
#
# Comments
#  -This is actually stuff I optimised out of fragstat.pl as it consumed a fair
#   bit of memory.  It's now a seperate script, which can produces a database
#   for a planned cgi program which will show all of the most killed and victim
#   of stats
#  -Currently using about 8/9Mb to process 2000 players, P100, runtime 1min
#  -Can be executed at the same time as fragstat.pl (background job)
#  -Set to write to a second database, so the critical period where files
#   change is minimised, (file copying)
#
# To do
#   Use generated key to save memory
#

require "/usr/local/bin/frag-lib.pl";	# rawstats common functions

# === User changeable =========================================================
$deathsdb = "/var/lib/qw/deaths2.db";
$fragsdb = "/var/lib/qw/frags2.db";

# =============================================================================

# read in player id file
open(PLAYIDDB, "$playiddb") or die "Can't open $playiddb: $!\n";
while ($line = <PLAYIDDB>) {
  chop $line;
  ($playid,$player) = split (/,/,$line);
  $id{$player} = $playid;
}
close PLAYIDDB;

# =============================================================================
open(F_FRAGS, "$fraglogs") or die "Can't open frag logs $fraglogs: $!\n";

while ($line = <F_FRAGS>) {
  chop $line;
  $slashct = $line =~ tr/\\/\\/;
  if ($slashct==3) {
    $line =~ s/(,)//g;				# strip commas
    $line =~ s/\\(.*?)\\(.*?)\\/$1,$2/;		# now in [name,name] format
    ($killer,$victim) = split(",",$line);	# split on comma
    $killer = $id{$killer};
    $victim = $id{$victim};

    $frags{$killer}++;					# calc frags
    $frags{$victim} += 0;				# use field
    $deaths{$victim}++;					# calc deaths
    if ($hitlist{$killer,$victim} == 0) {
      $hitnames{$killer} .= "$victim,";
    }
    if ($giblist{$victim,$killer} == 0) {
      $gibnames{$victim} .= "$killer,";
    }
    $hitlist{$killer,$victim}++;
    $giblist{$victim,$killer}++;
  } else {
#    print "[$line] Line isn't in correct format\n";
  }
}
close F_FRAGS;

# Work out amounts eacch user fragged or was gibbed by and who the players were

# $play_ct = 0;

open FRAGSDB, ">$fragsdb" or die "Can't create frags database";
open DEATHSDB, ">$deathsdb" or die "Can't create deaths database";

foreach $killer (sort keys %frags) {
  if ($killer eq "") {
    next;
  }
  @kill_lst = split(",", $hitnames{$killer});
  @death_lst = split(",", $gibnames{$killer});
  print FRAGSDB $killer, ",";
  print DEATHSDB $killer, ",";
#  $play_ct++;
  foreach $player (@kill_lst) {
    print FRAGSDB "$player\\$hitlist{$killer,$player},";
  }
  foreach $player (@death_lst) {
    print DEATHSDB "$player\\$giblist{$killer,$player},";
  }
  print FRAGSDB "\n";
  print DEATHSDB "\n";
}

close FRAGSDB;
close DEATHSDB;

# print "Total players $play_ct\n";

