#!/usr/bin/perl
#f:\perl\perl.exe
# Generate web pages from stats.db (generated by fragstat.pl)
# Fragrank.pl - V1.1 by Dog_food (email dog.food@poboxes.com)
#
# Changes
#  - now supports tracked players
#  - now supports lynx users better (sort of, not enabled tho :) 
#
# Mom, can I play out today?

require 'ctime.pl';
require "/usr/local/bin/frag-lib.pl";	# rawstats common functions
require "/usr/local/bin/fragpggn.pl";

# === User variables ==========================================================
$linknames = 1;			# use extra tags in webpage
$slink = $prefix . "1.html";	# starting webpage

# === Web page opening ========================================================
sub header {
	
$lastupd = &ctime(time);
$pageend = $playerpos + 99;
$prevpage = $pagenum - 2;
$nextpage = $pagenum;
$prevlink = $nextlink = "";
$barlink = &createbar;
$pagenum>2 && ($prevlink="<A HREF=$slink>Start page</A> <A HREF=$prefix$prevpage.html>Previous page</A>");
$nextlink = "<A HREF=$prefix$nextpage.html>Next page</A>";

print WEBPAGE <<EOHEADER
<HTML>
<TITLE>Rawstats - Rankings for $playerpos to $pageend</TITLE>
<BODY text=#FFFFFF bgcolor=#000000 LINK=#00FF00 VLINK=#00FFFF ALINK=#00FFFF>
<I>$barlink</I>
<CENTER>
<H1>Rankings for OrangeWorld and Baal's Playpen</H1>
<B>Last updated: $lastupd</B><BR>
<H3>Rankings $playerpos to $pageend</H3>
$prevlink $nextlink<BR><BR>
<TABLE BORDER=1 bgcolor=#224455>
<TR BGCOLOR=#335555>
	<TH><I>Pos</I></TH>
	<TH><I>Player</I></TH>
	<TH><I>Frags</I></TH>
	<TH><I>Deaths</I></TH>
	<TH><I>Suicides</I></TH>
	<TH><I>Score</I></TH>
	<TH><I>Rank</I></TH>
	<TH><I>Skill</I></TH>
	<TH><I>Efficiency</I></TH>
	<TH><I>Status</I></TH>
</TR>
EOHEADER
}

# === Web page trailer ========================================================
sub footer {
$lastupd = &ctime(time);
$pageend = $playerpos + 99;
$prevpage = $pagenum - 2;
$nextpage = $pagenum;
$prevlink = "";
$nextlink = "";
$slink = $prefix . "1.html";
if ($pagenum>2) {
  $prevlink = "<A HREF=$slink>Start page</A> <A HREF=$prefix$prevpage.html>Previous page</A>";
}
$nextlink = "<A HREF=$prefix$nextpage.html>Next page</A>";

print WEBPAGE <<EOFOOTER
</TABLE>
<BR>$prevlink $nextlink<BR><BR>
</CENTER>
<HR>
<B>Calculations</B>
<TABLE BORDER=1 bgcolor=#004422>
<TR>
	<TD><B>Score</B></TD>
	<TD>2*Frags - Deaths - 2*Suicides</TD>
</TR><TR>
	<TD><B>Rank</B></TD>
	<TD>Frags - Deaths</TD>
</TR><TR>
	<TD><B>Skill</B></TD>
	<TD>This depends upon who you kill, your minimum skill level is 1000, each time
	you kill someone 1/200th of their skill is added to your skill, everytime you
	get killed you lose 1/200th of your own skill.  This is calculated at the
	time of kill so a player killing someone who was once crap, but are now doing
	well will not profit from their improved skills</TD>
</TR><TR>
	<TD><B>Efficiency</B></TD>
	<TD>Percentage of frags over deaths. 100%=very good (frags&gtdeaths),
	-100%=very bad(frags&ltdeaths)</TD>
</TR><TR>
	<TD><B>Status</B></TD>
	<TD>This is the change in position, you can move up or down the rankings
	table. People moving up, may push others further down.</TD>
</TR>
</TABLE>
<BR>
<FONT SIZE=-1>
Ranking list by Dog_food V1.0b 2/6/97<BR>
Email <A HREF="mailto:dog.food\@poboxes.com">dog.food\@poboxes.com</A><BR>
</FONT></BODY>
</HTML>
EOFOOTER
}

# === Generate a single row of stats for a player =============================
sub tabrow {
#  $place,$killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$chg
  local $name = $_[1];
  local $buffer;

  $buffer = "<TR ALIGN=right>";
  for ($i=0; $i<=9; $i++) {
    if ($i==1 && $linknames) {
      $buffer .= sprintf "<TD>%s</TD>", createlink($name,$linknames);
    } elsif ($i==9) {
      if ($_[9] == 0) {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"sm-yell.gif\"ALT=\"Same at $_[10]\"></TD>";
      } elsif ($_[9] < 0) {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"up-grn.gif\"ALT=\"Up from $_[10]\"></TD>";
      } else {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"dn-red.gif\"ALT=\"Down from $_[10]\"></TD>";
      }
    } elsif ($i==8) {
      $buffer .= "<TD>$_[8]%</TD>";
    } else {
      $buffer .= "<TD>$_[$i]</TD>";
    }
  }
  $buffer .= "</TR>\n";
  return $buffer;
}

# =============================================================================
# Main

$playerpos = 1;
$pagenum = 1;
$splitct = 0;

# === read in player id file ==================================================
open(PLAYIDDB, "$playiddb") or die "Can't open $playiddb: $!\n";
while ($line = <PLAYIDDB>) {
  chop $line;
  ($playid,$player) = split (/,/,$line);
  $id{$playid} = $player;
}
close PLAYIDDB;

# === read in pre processed stats file ========================================
open(STATDB, "$statpath") or die "Can't open $statpath: $!\n";
while ($line = <STATDB>) {
  if (!iscomment($line)) {	# strip comments
  chop $line;
    if ($splitct == 0) {
      $splitct++;
      open(WEBPAGE, ">$outpath$prefix$pagenum.html");
      $pagenum++;
      header;
      $pagebuff = "";
    }

    ($killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$ma,$mb,$mc,$da,$db,$dc,$chg,$lst) = split(",",$line);
    $killer = $id{$killer};
    $pagebuff .=
    tabrow($playerpos,$killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$chg,$lst);
    $playerpos++;
    $splitct++;
    if ($splitct == $splitpage+1) {
      print WEBPAGE $pagebuff;
      footer;
      close WEBPAGE;
      $splitct = 0;
    }
  }
}
if ($splitct != 0) {		# finish on final stats page
  print WEBPAGE $pagebuff;
  footer;
  close WEBPAGE;
}
close STATDB;

# Create next page, which is blank and linked to the first page
open(WEBPAGE, ">$outpath$prefix$pagenum.html");
print WEBPAGE "<HTML><TITLE>End of the line</TITLE>";
print WEBPAGE "<BODY text=#FFFFFF bgcolor=#000000 LINK=#00FF00 VLINK=#00FFFF ALINK=#00FFFF>";
print WEBPAGE "No more players left, go back to the <A HREF=$slink>start</A></HTML>";
close WEBPAGE;

&makeqwrpage($pagenum-1);	# generate qwranks.html
&makesrchpage;			# generate search.html
