#!/usr/bin/perl
#f:\perl\perl.exe
# Rawstats - player searhing through stats.db
# fragsrch.pl - Version 1.2, (makes V1.0 Obsolete)

require "/usr/local/bin/frag-lib.pl";	# rawstats common functions

# === User variables ==========================================================
$src_db = "/var/lib/qw/stats.db";	# location of stats database file
$linknames = 1;				# use extra tags in webpage
$maxresults = 100;

# === Web page opening ========================================================
sub header {
	
$barlink = &createbar;

print "Content-Type: text/html\n\n";
print <<EOHEADER
<HTML>
<TITLE>Rawstats - Player search results for "$searchkey"</TITLE>
<BODY text=#FFFFFF bgcolor=#000000 LINK=#00FF00 VLINK=#00FFFF ALINK=#00FFFF>
<I>$barlink</I>
<CENTER>
<H1>Player search results</H1>
<FORM METHOD=GET action="/cgi-bin/fragsrch.pl">
  <TABLE BORDER=1 bgcolor=#004422><TR>
  <TD><B>Player search</B></TD>
  <TD><INPUT NAME=name value=$searchkey>&nbsp;<INPUT type=submit value=Search>&nbsp;</TD>
  </TR></TABLE>
</FORM>

<TABLE BORDER=1 BGCOLOR=#224455>
<TR BGCOLOR=#335555>
	<TH><I>Pos</I></TH>
	<TH><I>Player</I></TH>
	<TH><I>Frags</I></TH>
	<TH><I>Deaths</I></TH>
	<TH><I>Suicides</I></TH>
	<TH><I>Score</I></TH>
	<TH><I>Rank</I></TH>
	<TH><I>Skill</I></TH>
	<TH><I>Efficiency</I></TH>
	<TH><I>Status</I></TH>
</TR>
EOHEADER
}

# === Web page trailer ========================================================
sub footer {

($results==0) && ($res_txt="No results found");
($results==1) && ($res_txt="One result found");
($results>1) && ($res_txt="$results results found");
$playerct = $playerpos+1;

print <<EOFOOTER
</TABLE>
<BR>$res_txt, from $playerct players
</CENTER>
<HR>

<B>Searching</B>
<BR>This search is a substring search, if you are unsure of characters in a
name, for example, does a name end with 'X' or 'O'.  Well, you can use a search
key like 'Gibbed[XO]'.  To search for square brackets use something like
'\\[WK\\]' or '\\[OCR\\]' as your searchkey. Special characters which require a
prefixed escape code '\\' are '*, \[, \], \(, \)'<BR><BR>

<B>Calculations</B>
<TABLE BORDER=1 bgcolor=#004422>
<TR>
	<TD><B>Score</B></TD>
	<TD>2*Frags - Deaths - 2*Suicides</TD>
</TR><TR>
	<TD><B>Rank</B></TD>
	<TD>Frags - Deaths</TD>
</TR><TR>
	<TD><B>Skill</B></TD>
	<TD>This depends upon who you kill, your minimum skill level is 1000, each time
	you kill someone 1/200th of their skill is added to your skill, everytime you
	get killed you lose 1/200th of your own skill.  This is calculated at the
	time of kill so a player killing someone who was once crap, but are now doing
	well will not profit from their improved skills</TD>
</TR><TR>
	<TD><B>Efficiency</B></TD>
	<TD>Percentage of frags over deaths. 100%=very good (frags&gtdeaths),
	-100%=very bad(frags&ltdeaths)</TD>
</TR>
</TABLE>
<BR>
<FONT SIZE=-1>
Rawstats - Player search - V1.2, 10/6/97 <BR>
Email <A HREF="mailto:dog.food\@poboxes.com">dog.food\@poboxes.com</A><BR>
</FONT></BODY>
</HTML>
EOFOOTER
}

# === Generate normal line of player stats ====================================
sub tabrow {
#  $place,$killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$chg
  local $name = $_[1];
  local $buffer;

  $buffer = "<TR ALIGN=right>";
  for ($i=0; $i<=9; $i++) {
    if ($i==1 && $linknames) {
      $buffer .= sprintf "<TD>%s</TD>", createlink($name,$linknames);
    } elsif ($i==9) {
      if ($_[9] == 0) {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"/sm-yell.gif\"ALT=\"Same at $_[10]\"></TD>";
      } elsif ($_[9] < 0) {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"/up-grn.gif\"ALT=\"Up from $_[10]\"></TD>";
      } else {
        $buffer .= "<TD ALIGN=center><IMG SRC=\"/dn-red.gif\"ALT=\"Down from $_[10]\"></TD>";
      }
    } elsif ($i==8) {
      $buffer .= "<TD>$_[8]%</TD>";
    } else {
      $buffer .= "<TD>$_[$i]</TD>";
    }
  }
  $buffer .= "</TR>\n";
  return $buffer;
}

###########################################################################
# main

$searchkey = $ARGV[0];
$QUERY_STRING = $ENV{'QUERY_STRING'};
@vars = split ("&",$QUERY_STRING);

foreach $var (@vars) {
  ($varname, $vardata) = split ("=",$var);
  $vardata =~ s/\+/ /g;
  $vardata =~ s/%([a-fA-F0-9]{2})/chr(hex($1))/ge;
  $fields{$varname} = $vardata;
}
if ($searchkey eq "") {			# if not only cmdline, then assume web
  $searchkey = $fields{"name"};		# was used, using the get method
  &logcgi();
}

# === read in player id file ==================================================
open(PLAYIDDB, "$playiddb") or die "Can't open $playiddb: $!\n";
while ($line = <PLAYIDDB>) {
  chop $line;
  ($playid,$player) = split (/,/,$line);
  $id{$playid} = $player;
}
close PLAYIDDB;

$playerpos = 1;
$results = 0;

header;
if ($searchkey eq "") {
  print "No searchkey given\n";
} else {
  open(STATDB, "$statpath") or die "Can't open $statpath: $!\n";
  while ($line = <STATDB>) {
    if (!iscomment($line)) {	# strip comments
      chop $line;
      ($killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$ma,$mb,$mc,$da,$db,$dc,$chg,$lst) = split(",",$line);
      $killer = $id{$killer};
      if ($killer =~ /$searchkey/ig) {
        print tabrow($playerpos,$killer,$kills,$deaths,$suicides,$score,$rank,$skill,$eff,$chg,$lst);
        $results++;
      }
      $playerpos++;
    }
    if ($results == $maxresults) {
      last;
    }
  }
}
footer;

close STATDB;
