#!/usr/bin/perl
#f:\perl\perl.exe
# ===========================================================================
# Fragstat.pl - V1.1 by Dog_food (email dog.food@poboxes.com)
#
# Webpage : http://130.88.128.166/~bob/
# Info : Quakeworld ranking script
#
# Licence : Freeware - do what you will with this file, if you make any
#   interesting changes that will benefit the Quake community, email or
#   upload the new script to the above address.  Oh BTW, the disclaimer,
#   if the hard drive/system dies, falls to bits, gets squashed by a
#   passing moo using to this script, it's nothing to do with me.
#
# To do
#  documentation - hmmm, should I create one? or do I leave loads of comments
#   in the scripts?
#  create database editor
#  finish java version of rankings (client side calcations)
#  graphing of player's frag history
#  maybe show progress of players between updates ie up/down/same ie charts
#  maybe editor to remove shit players
#  use multiple log files, I seem to be losing players when using glob *.log
#   and doing the same process (just use one log file frag.dat for now)
#
# Requires
#  fragrank.pl - this generates rankings for ALL players in the form of
#                webpages.  It's not the same as the page generated here as
#                this lists only players over a fraglimit
#  stats.db - not used by this script, just generated, used by fragrank.pl
#  Perl V5+ (currently works on Win32/Linux)
#  Lots of memory would helps, currently about ~12mb for 2000 players, any
#   less and you'll probably notice the large drive thrashing away
#  Quake log files - just cat all log files in one big file and run script
#  Player names can't have the following characters "\," as they are required
#   by for filtering names and internal separators. I could use a hibit char,
#   but this is easier :)
#
# Notes
#  -average rank for all players is zero unless admin cheat by alter the
#    stats.db file (don't do it! ;).
#  -Forced version 1.0 to maintain release date (it's useable)
#  -I really should add in consistency checking but it so slow :(
#  -Hmmm, Dum de dum
#
# Changes
#  -Another sort key has been added to reflect 'a better player performance' by
#    sorting by the player's skill level
#  -cleaner code, removed debugging info
#  -links to all names (optional now)
#  -changed fields so that they are never empty (useful for java tokenising)
#  -added webpages into script, rather than using seperate files
#  -added back in original stuff, I optimised out for speed
#  -renamed a few variables
#  -more optimising, uses less memory and is faster
#  -added user variables
#  -tookout internal check for corrupt log files
#  -finally did a outfile for webpage
#  -change to database format, now subsequent files require playid.db, eases
#   memory requires in other scripts slightly, also it's smaller and easier to
#   download from a java client
#  -mr nobody has been removed (probably comes from server crashes)
#
# Jab, Bang, BOOM, splat, "Shit! no ammo", "Doomed, we're all DOOMED!"
# Woof, Kill the moo

require 'ctime.pl';			# last time this script was ran
require "/usr/local/bin/frag-lib.pl";	# rawstats common functions

# === User changeable =========================================================
$minfrag = 300;				# min frag limit for webpage
$fragver = "V1.0a 31/5/97";		# version of this script
$linknames = 1;				# use 0 to turn off

# === Web page opening ========================================================
sub header {
#  print "Content-Type: text/html\n\n";

$barlink = &createbar(4);

print WEBPAGE <<EOHEADER
<HTML>
<TITLE>Rawstats - Fragstats for top 100 players</TITLE>
<BODY text=#FFFFFF bgcolor=#000000 LINK=#00FF00 VLINK=#00FFFF ALINK=#00FFFF>
<I>$barlink</I>
<H1>Rawstats  - Fragstats for top 100 players</H1>
<BR>This compilation ranks only the dedicated players who have currently gained
    more than <B>$minfrag</B> frags.  Gib some more if your name isn't here. If
    the number of players listed exceeds 100, the min frag limit will be
    increased.
<BR><BR>
<CENTER>
<TABLE BORDER=1 bgcolor=#224455>
<TR>
	<TH>Pos</TH>
	<TH>Player</TH>
	<TH>Frags</TH>
	<TH>Deaths</TH>
	<TH>Suicides</TH>
	<TH>Score</TH>
	<TH>Rank</TH>
	<TH>Skill</TH>
	<TH>Efficiency</TH>
	<TH>Mostly killed</TH>
	<TH>Frags</TH>
	<TH>Mostly victim of</TH>
	<TH>Deaths</TH>
</TR>
EOHEADER
}

# === Web page trailer ========================================================
sub footer {

print WEBPAGE <<EOFOOTER
</TABLE>
</CENTER>
<BR><BR>
Listed $playerused of $playerct players<BR>
<HR>
<B>Calculations</B>
<TABLE BORDER=1 bgcolor=#004422>
<TR>
	<TD><B>Score</B></TD>
	<TD>2*Frags - Deaths - 2*Suicides</TD>
</TR><TR>
	<TD><B>Rank</B></TD>
	<TD>Frags - Deaths</TD>
</TR><TR>
	<TD><B>Skill</B></TD>
	<TD>This depends upon who you kill, your minimum skill level is 1000, each time
	you kill someone 1/200th of their skill is added to your skill, everytime you
	get killed you lose 1/200th of your own skill.  This is calculated at the
	time of kill so a player killing someone who was once crap, but are now doing
	well will not profit from their improved skills</TD>
</TR><TR>
	<TD><B>Efficiency</B></TD>
	<TD>Percentage of frags over deaths. 100%=very good (more frags than deaths),
	,0%=average (frags and deaths are the same), -100%=very bad (more deaths than
	frags) For example 50% means you die once for every two frags or there abouts
	</TD>
</TR><TR>
	<TD><B>Mostly killed</B></TD>
	<TD>This is the person you have gained most of your frags from, also shows
	number of frags and percentage of your total frags.  Only one victim is shown
	here</TD>
</TR><TR>
	<TD><B>Mostly Victim of</B></TD>
	<TD>This is person who killed you the most (you could be your own worst
	enermy), also shows number of deaths by the person and percentage
	of your total deaths.  Only one killer is shown here</TD>
</TR>
</TABLE>
<BR>
<FONT SIZE=-1>
Last updated: $lastupd<BR>
Rawstats by Dog_food $fragver<BR>
Email <A HREF="mailto:dog.food\@poboxes.com">dog.food\@poboxes.com</A><BR>
</FONT></BODY>
</HTML>
EOFOOTER
}

# === System globals - don't change these =====================================
$playerct = 0;
$samehit = 0;
$playerused = 0;
$hashrank = 999999;			# used for hash sorting, ">real rank"
$hashskill = 999999;			# used for hash sorting, ">real skill"
$lastupd = &ctime(time);		# get current time, used later
chop $lastupd;

# === Calculation +/- percentage of kills/deaths ==============================
sub calc_eff {
  local($kills,$gibbed) = @_;
  local $eff;

  if ($kills > $gibbed) {
    $eff = 100/$kills;
    $eff = int (100 - $eff*$gibbed);
  } elsif ($kills < $gibbed) {
    $eff = 100/$gibbed;
    $eff = - int (100 - $eff*$kills);
  } else {
    $eff = 0;
  }
  return $eff;
}

# === Reset the skill level if skill is below 1000 ============================
sub reset_skill {
  local($skill) = @_;
  ($skill<1000) && ($skill=1000);
  return $skill;
}

# ===========================================================================
# Only pass through this file once
# Stripping of certain characters required for external scripts
open(F_FRAGS, "$fraglogs") or die "Can't open frag logs $fraglogs: $!\n";
$next_id = 1;
while ($line = <F_FRAGS>) {
  chop $line;
  $slashct = $line =~ tr/\\/\\/;
  if ($slashct!=3) {
    next;
  }
  
  $line =~ s/(,)//g;			# strip commas
  $line =~ s/</&lt/g;			# get rid of possible html tags
  $line =~ s/>/&gt/g;			# get rid of possible html tags
  $line =~ s/\\(.*?)\\(.*?)\\/$1,$2/;	# now in [name,name] format
  ($killer,$victim) = split(",",$line);	# split on comma
  
  if (($killer eq "") || ($victim eq "")) {	# get rid of mr nobody
    next;
  }
  
  $frags{$killer}++;			# calc frags
  $frags{$victim}+=0;			# use field
  $deaths{$victim}++;			# calc deaths

  $skill{$killer} = reset_skill($skill{$killer});	# calc skill
  $skill{$victim} = reset_skill($skill{$victim});
  $skillval = $skill{$victim}*0.005;
  $skill{$killer} += $skillval;
  $skill{$victim} -= $skillval;
  if ($killer eq $victim) {				# calc suicides
    $frags{$killer}--;
    $suicide{$killer}++;
    $skill{$killer} -= $skillval;
  }
  $skill{$victim} = reset_skill($skill{$victim});	# reset

# add up hits on players
  $hitlist{$killer,$victim}++;
  if ($hitlist{$killer,$victim} > $hitcount{$killer}) {
    $hitcount{$killer} = $hitlist{$killer,$victim};
    $tophit{$killer} = $victim;
  }
# add up deaths from players
  $giblist{$victim,$killer}++;
  if ($giblist{$victim,$killer} > $gibcount{$victim}) {
    $gibcount{$victim} = $giblist{$victim,$killer};
    $topgib{$victim} = $killer;
  }    

# build up id table
  ($id{$killer} == 0) && ($id{$killer}=$next_id++);
  ($id{$victim} == 0) && ($id{$victim}=$next_id++);
}
close F_FRAGS;

# =============================================================================
# Benchmark - should get to this point within 1 min for 2000 players P100 16Mb

# Write out all player ids
open PLAYIDDB, ">$playiddb" or die "Can't create player id database";
foreach $killer (sort keys %id) {
  print PLAYIDDB "$id{$killer},$killer\n";
}
close PLAYIDDB;

# =============================================================================
# Generate unique sort key (combo padded rank + name)
# Comment out to leave only one sorting key
foreach $killer (sort keys %frags) {
#  $skey = sprintf "%07d%07d%s", $hashrank - ($frags{$killer} - $deaths{$killer}), $frags{$killer}, $killer;
  $skey = sprintf "%07d%07d%s", $hashskill - $skill{$killer}, $frags{$killer}, $killer;
  $sortkey{$skey} = $killer;
} 

# =============================================================================
open WEBPAGE, ">$fragpage" or die "Can't create webpage";
header;

open STATDB, ">$statpath" or die "Can't create stats database";
print STATDB "\\ Stats database - generated by fragstat.pl\n";
print STATDB "\\ Do not edit - Version 1.1\n";
print STATDB "\\ Last updated $lastupd\n";

foreach $skey (sort keys %sortkey) {
  $killer = $sortkey{$skey};
  $playerct++;

  $deaths{$killer}+=0;				# make sure fields are used
  $suicide{$killer}+=0;				#
  $gibcount{$victim}+=0;			#
  $gibcount{$killer}+=0;			#
  $hitcount{$killer}+=0;			#
  $hitcount{$victim}+=0;			#
    
  $kills = $frags{$killer};
  $gibbed = $deaths{$killer};
  $oops = $suicide{$killer};
  $score = 2*$kills - $gibbed - 2*$oops;
  $rank = $kills - $gibbed;
  $eff = calc_eff($kills,$gibbed);
  $skill = int ($skill{$killer});

  $hitage = $blastage = 0;			# assume defaults
  $kills>0 && ($hitage=(100/$kills) * $hitcount{$killer});
  $gibbed>0 && ($blastage=(100/$gibbed) * $gibcount{$killer});
  
  $hitage = int $hitage;
  $blastage = int $blastage;
  if ($kills>$minfrag) {
    $playerused++;
    print WEBPAGE "<TR ALIGN=right><TD>$playerused</TD>";
    printf WEBPAGE "<TD>%s</TD>", createlink($killer,$linknames);
    print WEBPAGE "<TD>$kills</TD><TD>$gibbed</TD><TD>$oops</TD><TD>$score</TD><TD>$rank</TD><TD>$skill</TD><TD>$eff%</TD>";
    printf WEBPAGE "<TD>%s</TD>", createlink($tophit{$killer},$linknames);
    print WEBPAGE "<TD>$hitcount{$killer} ($hitage%)</TD>";
    printf WEBPAGE "<TD>%s</TD>", createlink($topgib{$killer},$linknames);
    print WEBPAGE "<TD>$gibcount{$killer} ($blastage%)</TD></TR>\n";
  }

  if ($id{$tophit{$killer}} eq "") {	# output a non-empty field (for java's sake!)
    $id{$tophit{$killer}} = 0;
  }
  if ($id{$topgib{$killer}} eq "") {
    $id{$topgib{$killer}} = 0;
  }
  # output to stats database file
  print STATDB "$id{$killer},$kills,$gibbed,$oops,$score,$rank,$skill,$eff,";
  print STATDB "$id{$tophit{$killer}},$hitcount{$killer},$hitage,";
  print STATDB "$id{$topgib{$killer}},$gibcount{$killer},$blastage\n";
}
close STATDB;

footer;

close WEBPAGE;

